Index: src/org/armedbear/lisp/LispThread.java
===================================================================
--- src/org/armedbear/lisp/LispThread.java	(revision 12632)
+++ src/org/armedbear/lisp/LispThread.java	(working copy)
@@ -930,6 +930,27 @@
         }
     };
 
+    private static final Primitive THREAD_JOIN =
+        new Primitive("thread-join", PACKAGE_THREADS, true, "thread",
+                      "Waits for thread to finish.")
+    {
+        @Override
+        public LispObject execute(LispObject arg)
+        {
+            if (arg instanceof LispThread) {
+                try {
+                    ((LispThread) arg).javaThread.join();
+                } catch (InterruptedException e) {
+                    currentThread().processThreadInterrupts();
+                }
+                return NIL;
+            } else {
+                return type_error(arg, Symbol.THREAD);
+            } 
+        }
+    };
+
+
     public static final long javaSleepInterval(LispObject lispSleep)
 
     {
